# This script is created by NSG2 beta1
# <http://wushoupong.googlepages.com/nsg>

#===================================
#     Simulation parameters setup
#===================================
set val(stop)   100.0                         ;# time of simulation end
set val(rate)	50kb
set val(report_interval) 1000ms

#===================================
#        Initialization        
#===================================
#Create a ns simulator
set ns [new Simulator -multicast on]
#Define different colors for data flows
$ns color 1 red
$ns color 30 purple
$ns color 31 bisque
$ns color 32 green


#Open the NS trace file
set tracefile [open out.tr w]
$ns trace-all $tracefile

#Open the NAM trace file
set namfile [open out.nam w]
$ns namtrace-all $namfile

#Open trace files
set l0 [open smooth_loss0.tr w]
set j0 [open jitter0.tr w]



#===================================
#        Nodes Definition        
#===================================
#Create 13 nodes
set n0 [$ns node]
set n1 [$ns node]
set n2 [$ns node]
set n3 [$ns node]
set n4 [$ns node]
set n5 [$ns node]
set n6 [$ns node]
set n7 [$ns node]
set n8 [$ns node]
set n9 [$ns node]
set n10 [$ns node]
set n11 [$ns node]
set n12 [$ns node]

$n0 shape "box"
$n1 shape "box"
$n2  label "RTP-Sender"
$n3  label "RTP-Receiver"
$n4  label "RTP-Receiver"


#===================================
#        Links Definition        
#===================================
#Createlinks between nodes
$ns duplex-link $n2 $n0 10.0Mb 10ms DropTail
$ns queue-limit $n2 $n0 50
$ns duplex-link $n5 $n0 10.0Mb 10ms DropTail
$ns queue-limit $n5 $n0 50
$ns duplex-link $n6 $n0 10.0Mb 10ms DropTail
$ns queue-limit $n6 $n0 50
$ns duplex-link $n7 $n0 10.0Mb 10ms DropTail
$ns queue-limit $n7 $n0 50
$ns duplex-link $n8 $n0 10.0Mb 10ms DropTail
$ns queue-limit $n8 $n0 50
$ns duplex-link $n3 $n1 1.5Mb 10ms DropTail
$ns queue-limit $n3 $n1 50
$ns duplex-link $n4 $n1 1.5Mb 10ms DropTail
$ns queue-limit $n4 $n1 50
$ns duplex-link $n9 $n1 1.5Mb 10ms DropTail
$ns queue-limit $n9 $n1 50
$ns duplex-link $n10 $n1 1.5Mb 10ms DropTail
$ns queue-limit $n10 $n1 50
$ns duplex-link $n11 $n1 1.5Mb 10ms DropTail
$ns queue-limit $n11 $n1 50
$ns duplex-link $n12 $n1 1.5Mb 10ms DropTail
$ns queue-limit $n12 $n1 50
$ns duplex-link $n0 $n1 5.0Mb 10ms RED
$ns queue-limit $n0 $n1 50

#===================================
#        Agents Definition        
#===================================
#Setup a TCP connection
set tcp0 [new Agent/TCP]
$ns attach-agent $n5 $tcp0
set sink4 [new Agent/TCPSink]
$ns attach-agent $n9 $sink4
$ns connect $tcp0 $sink4
$tcp0 set packetSize_ 1000

#Setup a TCP connection
set tcp1 [new Agent/TCP]
$ns attach-agent $n6 $tcp1
set sink5 [new Agent/TCPSink]
$ns attach-agent $n10 $sink5
$ns connect $tcp1 $sink5
$tcp1 set packetSize_ 1000

#Setup a TCP connection
set tcp2 [new Agent/TCP]
$ns attach-agent $n7 $tcp2
set sink6 [new Agent/TCPSink]
$ns attach-agent $n11 $sink6
$ns connect $tcp2 $sink6
$tcp2 set packetSize_ 1000

#Setup a TCP connection
set tcp3 [new Agent/TCP]
$ns attach-agent $n8 $tcp3
set sink7 [new Agent/TCPSink]
$ns attach-agent $n12 $sink7
$ns connect $tcp3 $sink7
$tcp3 set packetSize_ 1000

#===================================
#        Applications Definition
#===================================
#Setup a FTP Application over TCP connection
set ftp0 [new Application/FTP]
$ftp0 attach-agent $tcp0
$ns at 1.0 "$ftp0 start"
$ns at 100.0 "$ftp0 stop"

#Setup a FTP Application over TCP connection
set ftp1 [new Application/FTP]
$ftp1 attach-agent $tcp1
$ns at 1.0 "$ftp1 start"
$ns at 100.0 "$ftp1 stop"

#Setup a FTP Application over TCP connection
set ftp2 [new Application/FTP]
$ftp2 attach-agent $tcp2
$ns at 1.0 "$ftp2 start"
$ns at 100.0 "$ftp2 stop"

#Setup a FTP Application over TCP connection
set ftp3 [new Application/FTP]
$ftp3 attach-agent $tcp3
$ns at 1.0 "$ftp3 start"
$ns at 100.0 "$ftp3 stop"

#===================================
#        RTP-TCP Friendly Multicast
#===================================
# configure multicast protocol;
#set mproto CtrMcast
set mproto DM
# all nodes will contain multicast protocol agents;
set mrthandle [$ns mrtproto $mproto]         
# allocate a multicast address;
set group [Node allocaddr]

# Node 2, the multicast sender
set s0 [new Session/RTP ]
$s0 report-interval $val(report_interval)
$s0 session_bw $val(rate)
$s0 initial-rate  $val(rate)
$s0 attach-node $n2
# enable TCP-Friendly congestion control
#by default is 0
$s0 enable-control 1

#Node 3, receiver
set s1 [new Session/RTP ]
$s1 report-interval $val(report_interval)
$s1 initial-rate  $val(rate)
$s1 session_bw  $val(rate)
$s1 attach-node $n3

#Node 4, receiver
set s2 [new Session/RTP ]
$s2 report-interval $val(report_interval)
$s2 initial-rate  $val(rate)
$s2 session_bw $val(rate)
$s2 attach-node $n4

#joining the group
$ns at 0.1 "$s0 join-group $group"
$ns at 0.1 "$s0 start"

$ns at 0.1 "$s1 join-group $group"
$ns at 0.1 "$s1 start"

$ns at 0.1 "$s2 join-group $group"
$ns at 0.1 "$s2 start"

#RTP sender starts transmission
$ns at 1.0 "$s0 transmit $val(rate)"

#===================================
#        Recording
#===================================
$ns at 1.0 "record-smooth-loss0"
$ns at 1.0 "record-jitter0"


#Node 4
proc record-smooth-loss0 {} {
      global s1 l0
        set ns [Simulator instance]
        set time 1
	set bw  [$s1 set smooth_loss_]
	set now [$ns now]
        puts $l0 "$now $bw"
        $ns at [expr $now+$time] "record-smooth-loss0"
}

#Node 4
proc record-jitter0 {} {
      global s1 j0
        set ns [Simulator instance]
        set time 1
	set bw  [$s1 set jitter_]
	set now [$ns now]
        puts $j0 "$now $bw"
        $ns at [expr $now+$time] "record-jitter0"
}




#===================================
#        Termination        
#===================================
#Define a 'finish' procedure
proc finish {} {
    global ns l0 j0 tracefile namfile
    $ns flush-trace
    close $tracefile
    close $namfile
    close $l0
    close $j0

    exec nam out.nam &
    #Call xgraph to display the results
    exec xgraph jitter0.tr   -geometry 800x400  &
    exec xgraph smooth_loss0.tr   -geometry 800x400  &
    exit 0
}

$ns at $val(stop) "finish"
$ns at $val(stop) "puts \"done\" ; $ns halt"
$ns run
